# WARNING: Please don't edit this file. It was generated by Python/WinRT v2.3.0

import datetime
import sys
import types
import typing
import uuid as _uuid
from builtins import property as _property

import winrt._winrt
import winrt.system
import winrt.windows.foundation as windows_foundation
import winrt.windows.foundation.collections as windows_foundation_collections
import winrt.windows.foundation.numerics as windows_foundation_numerics
import winrt.windows.graphics.directx as windows_graphics_directx
import winrt.windows.perception.spatial as windows_perception_spatial
import winrt.windows.storage.streams as windows_storage_streams

Self = typing.TypeVar('Self')

@typing.final
class SpatialSurfaceInfo(winrt.system.Object):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> SpatialSurfaceInfo: ...
    @typing.overload
    def try_compute_latest_mesh_async(self, max_triangles_per_cubic_meter: winrt.system.Double, /) -> windows_foundation.IAsyncOperation[SpatialSurfaceMesh]: ...
    @typing.overload
    def try_compute_latest_mesh_async(self, max_triangles_per_cubic_meter: winrt.system.Double, options: typing.Optional[SpatialSurfaceMeshOptions], /) -> windows_foundation.IAsyncOperation[SpatialSurfaceMesh]: ...
    def try_get_bounds(self, coordinate_system: typing.Optional[windows_perception_spatial.SpatialCoordinateSystem], /) -> typing.Optional[typing.Optional[windows_perception_spatial.SpatialBoundingOrientedBox]]: ...
    @_property
    def id(self) -> _uuid.UUID: ...
    @_property
    def update_time(self) -> datetime.datetime: ...

@typing.final
class SpatialSurfaceMesh(winrt.system.Object):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> SpatialSurfaceMesh: ...
    @_property
    def coordinate_system(self) -> typing.Optional[windows_perception_spatial.SpatialCoordinateSystem]: ...
    @_property
    def surface_info(self) -> typing.Optional[SpatialSurfaceInfo]: ...
    @_property
    def triangle_indices(self) -> typing.Optional[SpatialSurfaceMeshBuffer]: ...
    @_property
    def vertex_normals(self) -> typing.Optional[SpatialSurfaceMeshBuffer]: ...
    @_property
    def vertex_position_scale(self) -> windows_foundation_numerics.Vector3: ...
    @_property
    def vertex_positions(self) -> typing.Optional[SpatialSurfaceMeshBuffer]: ...

@typing.final
class SpatialSurfaceMeshBuffer(winrt.system.Object):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> SpatialSurfaceMeshBuffer: ...
    @_property
    def data(self) -> typing.Optional[windows_storage_streams.IBuffer]: ...
    @_property
    def element_count(self) -> winrt.system.UInt32: ...
    @_property
    def format(self) -> windows_graphics_directx.DirectXPixelFormat: ...
    @_property
    def stride(self) -> winrt.system.UInt32: ...

@typing.final
class SpatialSurfaceMeshOptions_Static(type):
    @_property
    def supported_triangle_index_formats(cls) -> typing.Optional[windows_foundation_collections.IVectorView[windows_graphics_directx.DirectXPixelFormat]]: ...
    @_property
    def supported_vertex_normal_formats(cls) -> typing.Optional[windows_foundation_collections.IVectorView[windows_graphics_directx.DirectXPixelFormat]]: ...
    @_property
    def supported_vertex_position_formats(cls) -> typing.Optional[windows_foundation_collections.IVectorView[windows_graphics_directx.DirectXPixelFormat]]: ...

@typing.final
class SpatialSurfaceMeshOptions(winrt.system.Object, metaclass=SpatialSurfaceMeshOptions_Static):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> SpatialSurfaceMeshOptions: ...
    def __new__(cls: typing.Type[SpatialSurfaceMeshOptions]) -> SpatialSurfaceMeshOptions: ...
    @_property
    def vertex_position_format(self) -> windows_graphics_directx.DirectXPixelFormat: ...
    @vertex_position_format.setter
    def vertex_position_format(self, value: windows_graphics_directx.DirectXPixelFormat) -> None: ...
    @_property
    def vertex_normal_format(self) -> windows_graphics_directx.DirectXPixelFormat: ...
    @vertex_normal_format.setter
    def vertex_normal_format(self, value: windows_graphics_directx.DirectXPixelFormat) -> None: ...
    @_property
    def triangle_index_format(self) -> windows_graphics_directx.DirectXPixelFormat: ...
    @triangle_index_format.setter
    def triangle_index_format(self, value: windows_graphics_directx.DirectXPixelFormat) -> None: ...
    @_property
    def include_vertex_normals(self) -> bool: ...
    @include_vertex_normals.setter
    def include_vertex_normals(self, value: bool) -> None: ...

@typing.final
class SpatialSurfaceObserver_Static(type):
    def is_supported(cls) -> bool: ...
    def request_access_async(cls) -> windows_foundation.IAsyncOperation[windows_perception_spatial.SpatialPerceptionAccessStatus]: ...

@typing.final
class SpatialSurfaceObserver(winrt.system.Object, metaclass=SpatialSurfaceObserver_Static):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> SpatialSurfaceObserver: ...
    def __new__(cls: typing.Type[SpatialSurfaceObserver]) -> SpatialSurfaceObserver: ...
    def get_observed_surfaces(self) -> typing.Optional[windows_foundation_collections.IMapView[_uuid.UUID, SpatialSurfaceInfo]]: ...
    def set_bounding_volume(self, bounds: typing.Optional[windows_perception_spatial.SpatialBoundingVolume], /) -> None: ...
    def set_bounding_volumes(self, bounds: typing.Iterable[windows_perception_spatial.SpatialBoundingVolume], /) -> None: ...
    def add_observed_surfaces_changed(self, handler: windows_foundation.TypedEventHandler[SpatialSurfaceObserver, winrt.system.Object], /) -> windows_foundation.EventRegistrationToken: ...
    def remove_observed_surfaces_changed(self, token: windows_foundation.EventRegistrationToken, /) -> None: ...

